//
//  WKWebViewController.swift
//  OpenUrlsTest2
//
//  Created by Mark Hunte on 12/06/2020.
//  Copyright © 2020 Mark Hunte. All rights reserved.
//
 

import UIKit
import WebKit
import SafariServices

class WKWebViewController: UIViewController, WKNavigationDelegate  ,WKScriptMessageHandler {
 
    
    //-- declare a WKWebView
    var webView: WKWebView!
    
    //-- declare a message name to use later
    let messageName = "openStore"
    
    //-- declare a your html file  name to use later ( do not include the .html )
    let htmlName = "OpenUrlsTest2"
    
    
    
    
    
      // MARK: - WKUserContentController:  -> webkit Posted messages handler delegate //-- handles messages from hype page
    func userContentController(_ userContentController: WKUserContentController, didReceive message: WKScriptMessage) {
       
          if message.name ==  "openStore" {
          print("\(message.body )")
          //-- Get the message passed to app
        let mssg    =  message.body as! String
         
             // anURL  = URL.init(string: message.body as! String)!
            if let url =  URL(string: "\(mssg)")  {
            //URL(string: "\(message.body)") else {
                let config = SFSafariViewController.Configuration()
                                   config.entersReaderIfAvailable = true
                
                let vc = SFSafariViewController(url: url, configuration: config)
                present(vc, animated: true)
                
                  return //be safe
              }
              
              
            
          }
        
        
        
    }
    
    
    
    override func viewDidLoad() {
        
        super.viewDidLoad()

        
        //-- configure the WKWebView
        
        //-- init config and controller
        let wconfiguration = WKWebViewConfiguration()
        let wcontroller = WKUserContentController()
        
//MARK: WKUserContentController Init :  We must add the webkit scripts Posted messages we expect to get from the Hype Page to the controller
        wcontroller.add(self, name:  messageName )
        
        //-- attach controller, config to WKWebview
        wconfiguration.userContentController = wcontroller;
        
 
        wconfiguration.allowsInlineMediaPlayback = true
        wconfiguration.mediaTypesRequiringUserActionForPlayback = []
 
        
        webView =  WKWebView(frame: .zero, configuration: wconfiguration)
        

        let  theFileName = (htmlName as NSString).lastPathComponent
        let htmlPath = Bundle.main.path(forResource: theFileName, ofType: "html")
        
        let folderPath = Bundle.main.bundlePath
        
        let baseUrl = URL(fileURLWithPath: folderPath, isDirectory: true)
        
        do {
            
            let htmlString = try NSString(contentsOfFile: htmlPath!, encoding: String.Encoding.utf8.rawValue)
            
            webView.loadHTMLString(htmlString as String, baseURL: baseUrl)
            
        } catch {
            
            // catch error
            
        }
        
        webView.navigationDelegate = self
      
        webView.scrollView.bounces = false
        webView.scrollView.isScrollEnabled = false
        webView.isOpaque = false
        webView.isHidden = false
 
        view = webView
        
    }
 
    
    
}

